diff --git a/nxdrive/client/remote_client.py b/nxdrive/client/remote_client.py
index c1b1f0f7e..448a229d8 100644
--- a/nxdrive/client/remote_client.py
+++ b/nxdrive/client/remote_client.py
@@ -35,13 +35,7 @@
     UploadAction,
     VerificationAction,
 )
-from ..exceptions import (
-    DirectTransferDuplicateFoundError,
-    DownloadPaused,
-    NotFound,
-    ScrollDescendantsError,
-    UploadPaused,
-)
+from ..exceptions import DownloadPaused, NotFound, ScrollDescendantsError, UploadPaused
 from ..objects import Download, NuxeoDocumentInfo, RemoteFileInfo, Upload
 from ..options import Options
 from ..utils import (
@@ -52,7 +46,6 @@
     unlock_path,
     version_le,
 )
-from .local import LocalClient
 from .proxy import Proxy
 
 if TYPE_CHECKING:
@@ -658,7 +651,7 @@ def link_blob_to_doc(
             LinkingAction.finish_action()
 
     def get_document_or_none(self, uid: str = "", path: str = "") -> Optional[Document]:
-        """Fetch a document base don given criteria or return None if not found on the server."""
+        """Fetch a document based on given criteria or return None if not found on the server."""
         doc: Optional[Document] = None
         try:
             doc = self.documents.get(uid=uid, path=path)
@@ -667,105 +660,6 @@ def get_document_or_none(self, uid: str = "", path: str = "") -> Optional[Docume
                 raise
         return doc
 
-    def direct_transfer(
-        self, file: Path, parent_path: str, engine_uid: str, replace_blob: bool = False
-    ) -> None:
-        """Upload a given file to the given folderish document on the server.
-
-        Note about possible duplicate creation via a race condition client <-> server.
-        Given the local *file* with the path "$HOME/some-folder/subfolder/file.odt",
-        the file name is "file.odt".
-
-        Scenario:
-            - Step 1: local, check for a doc with the path name "file.odt" => nothing returned, continuing;
-            - Step 2: server, a document with a path name set to "file.odt" is created;
-            - Step 3: local, create the document with the path name "file.odt".
-
-        Even if the elapsed time between steps 1 and 3 is really short, it may happen.
-
-        What can be done to prevent such scenario is not on the Nuxeo Drive side but on the server one.
-        For now, 2 options are possible but not qualified to be done in a near future:
-            - https://jira.nuxeo.com/browse/NXP-22959;
-            - create a new operation `Document.GetOrCreate` that ensures atomicity.
-        """
-        log.info(f"Direct Transfer of {file!r} into {parent_path!r}")
-
-        # The remote file, when created, is stored in the file xattrs.
-        # So retrieve it and if it is defined, the document creation should
-        # be skipped to prevent duplicate creations.
-        remote_ref = LocalClient.get_path_remote_id(file, name="remote")
-
-        doc: Optional[Document] = None
-
-        if remote_ref:
-            # The remote ref is set, so it means either the file has already been uploaded,
-            # either a previous upload failed: the document was created, or not, and it has
-            # a blob attached, or not. In any cases, we need to ensure the user can upload
-            # without headhache.
-            doc = self.get_document_or_none(uid=remote_ref)
-
-        if not doc:
-            # We need to handle possbile duplicates based on the file name and
-            # the destination folder on the server.
-            # Note: using this way may still result in duplicates:
-            #  - the user created 2 documents with the same name on Web-UI or another way
-            #  - the user then deleted the 1st document
-            #  - the other document has a path like "name.TIMESTAMP"
-            # So then Drive will not see that document as a duplicate because it will check
-            # a path with "name" only.
-
-            # If we really want to avoid that situation, we should use that commented code:
-            """
-            # Note that it would be too much effort for the server, we do not want that!
-            for child in self.documents.get_children(path=parent_path):
-                # It is OK to have a folder and a file with the same name,
-                # but not 2 files or 2 folders with the same name
-                if child.title == file.name:
-                    local_is_dir = file.isdir()
-                    remote_is_dir = "Folderish" in child["facets"]
-                    if local_is_dir is remote_is_dir:
-                        # Duplicate found!
-                        doc = child
-                        remote_ref = doc.uid
-                        break
-            """
-
-            doc = self.get_document_or_none(path=f"{parent_path}/{file.name}")
-            if doc:
-                remote_ref = doc.uid
-
-        if not replace_blob and doc and doc.properties.get("file:content"):
-            # The document already exists and has a blob attached. Ask the user what to do.
-            raise DirectTransferDuplicateFoundError(file, doc)
-
-        if not doc:
-            # Create the document on the server
-            nature = "File" if file.is_file() else "Folder"
-            doc = self.documents.create(
-                Document(
-                    name=file.name, type=nature, properties={"dc:title": file.name}
-                ),
-                parent_path=parent_path,
-            )
-            remote_ref = doc.uid
-
-        # If the path is a folder, there is no more work to do
-        if file.is_dir():
-            return
-
-        # Save the remote document's UID into the file xattrs, in case next steps fails
-        LocalClient.set_path_remote_id(file, remote_ref, name="remote")
-
-        # Upload the blob and attach it to the document
-        self.upload(
-            file,
-            engine_uid=engine_uid,
-            document=remote_ref,
-            command="Blob.AttachOnDocument",
-            xpath="file:content",
-            void_op=True,
-        )
-
     def get_fs_info(
         self, fs_item_id: str, parent_fs_item_id: str = None
     ) -> RemoteFileInfo:
diff --git a/nxdrive/constants.py b/nxdrive/constants.py
index f546c84a0..eeffe4d9d 100644
--- a/nxdrive/constants.py
+++ b/nxdrive/constants.py
@@ -96,3 +96,4 @@ class TransferStatus(Enum):
     PAUSED = auto()
     SUSPENDED = auto()
     DONE = auto()
+    ABORTED = auto()
diff --git a/nxdrive/data/qml/SystrayMenu.qml b/nxdrive/data/qml/SystrayMenu.qml
index 0a3fc7d0e..bf8f1ccf3 100755
--- a/nxdrive/data/qml/SystrayMenu.qml
+++ b/nxdrive/data/qml/SystrayMenu.qml
@@ -52,7 +52,7 @@ ShadowRectangle {
             text: qsTr("QUIT") + tl.tr
             onClicked: {
                 application.hide_systray()
-                application.quit()
+                application.exit_app()
             }
         }
 
diff --git a/nxdrive/direct_transfer/__init__.py b/nxdrive/direct_transfer/__init__.py
new file mode 100644
index 000000000..1be44055c
--- /dev/null
+++ b/nxdrive/direct_transfer/__init__.py
@@ -0,0 +1,7 @@
+"""
+The Direct Transfer feature.
+"""
+from .manager import DirectTransferManager
+from .uploader import DirectTransferDuplicateFoundError
+
+__all__ = ("DirectTransferDuplicateFoundError", "DirectTransferManager")
diff --git a/nxdrive/direct_transfer/manager.py b/nxdrive/direct_transfer/manager.py
new file mode 100644
index 000000000..84935b4ea
--- /dev/null
+++ b/nxdrive/direct_transfer/manager.py
@@ -0,0 +1,432 @@
+# coding: utf-8
+"""
+The Direct Transfer feature.
+
+What: the transfers manager.
+
+For now, transfers are done in sequence as it eases the implementation.
+For better performances, one should really use Nuxeo Drive.
+"""
+from collections import deque
+from datetime import datetime
+from logging import getLogger
+from operator import attrgetter
+from pathlib import Path
+from typing import TYPE_CHECKING, Callable, List, Optional, Set
+
+from PyQt5.QtCore import QCoreApplication
+
+from ..constants import CONNECTION_ERROR, TransferStatus
+from ..state import State
+from ..utils import get_tree_list
+from . import uploader
+from .models import DATABASE, MODELS, Session, Transfer
+from .runner import Runner
+
+if TYPE_CHECKING:
+    from nuxeo.handlers.default import Uploader  # noqa
+    from nuxeo.models import Document  # noqa
+
+    from .client.remote_client import Remote  # noqa
+
+
+log = getLogger(__name__)
+
+
+class DirectTransferManager:
+    """Direct Transfer manager.
+    This is the core of the feature, separated from Nuxeo Drive.
+    It is used to create a new Direct Transfer, keep track of the progression,
+    pause/resume transfers and it is connected to a (beautiful) custom QML component.
+    """
+
+    def __init__(
+        self,
+        db: str,
+        engine_uid: str,
+        remote: "Remote",
+        chunk_callback: Callable[["Uploader"], None] = lambda *_: None,
+        done_callback: Callable[[bool, int], None] = lambda *_: None,
+        dupe_callback: Callable[[Path, "Document"], None] = lambda *_: None,
+    ) -> None:
+        """
+        *chunk_callback* is triggered when a chunk is successfully uploaded.
+        *done_callback* is triggered when an upload was successfully done.
+        *dupe_callback* is triggered when a given upload would generate a duplicate on the server.
+        """
+        self.db = db
+        self.engine_uid = engine_uid
+        self.remote = remote
+        self.chunk_callback = chunk_callback
+        self.done_callback = done_callback
+        self.dupe_callback = dupe_callback
+
+        self.is_started = False
+        self.reinit()
+
+    def reinit(self) -> None:
+        """(Re)Initialize the database connection, refetch session and associated transfers."""
+        # Init the database
+        self.init_db(self.db)
+
+        # Retrieve the session or create a new one
+        self.session, _ = Session.get_or_create(finished=None)
+
+        # Retrieve associated transfers
+        transfers = Transfer.get_or_none(Transfer.session == self.session.id) or []
+        if not isinstance(transfers, list):
+            # 1 record in the database
+            transfers = [transfers]
+        self.transfers: List[Transfer] = transfers
+
+        # The thread-safe queue
+        self._iterator: deque = deque()
+
+        # Inject new methods
+        self.inject()
+
+    def __repr__(self) -> str:
+        return (
+            f"{type(self).__name__}<uid={self.engine_uid!r}"
+            f", db={self.db!r}"
+            f", paths={len(self.transfers)}"
+            f", completed={self.is_completed!r}"
+            f", started={self.is_started!r}"
+            f", progress={self.progress:.1f}"
+            f", size={self.size}"
+            f", uploaded={self.uploaded}"
+            ">"
+        )
+
+    def __iter__(self) -> "DirectTransferManager":
+        """The whole class is an iterator.
+        It is used to io iterate over transfers to handle:
+
+            >>> for transfer in self:
+            ...     upload(transfer)
+
+        """
+        self._iterator.clear()
+        self._iterator.extend(self.partitions)
+
+        return self
+
+    def __next__(self) -> Transfer:
+        """Get the next transfer to handle. See __iter__()."""
+        try:
+            return self._iterator.popleft()  # type: ignore
+        except IndexError:
+            raise StopIteration()
+
+    @property
+    def is_completed(self) -> bool:
+        """Return True when all transfers are done."""
+        return not self.uploading and self.progress >= 100.0
+
+    @property
+    def partitions(self) -> List[Transfer]:
+        """Return a list of paths to upload, sorted by remote path > file type > local path."""
+        return sorted(
+            self.transfers, key=attrgetter("remote_path", "is_file", "local_path")
+        )
+
+    @property
+    def progress(self) -> float:
+        """Overall progression."""
+        if not self.has_transfers_to_handle():
+            # All transfers are either done or aborted
+            return 100.0
+
+        return self.uploaded * 100.0 / self.size
+
+    @property
+    def size(self) -> int:
+        """Overall files size to upload."""
+        return sum(
+            transfer.file_size
+            for transfer in self.transfers
+            if transfer.status is not TransferStatus.ABORTED
+        )
+
+    @property
+    def uploaded(self) -> int:
+        """Overall uploaded size."""
+        return sum(
+            transfer.uploaded_size
+            for transfer in self.transfers
+            if transfer.status is not TransferStatus.ABORTED
+        )
+
+    @property
+    def uploading(self) -> List[Transfer]:
+        """Get the transfers being uploaded."""
+        return [
+            transfer
+            for transfer in self.transfers
+            if transfer.status is TransferStatus.ONGOING
+        ]
+
+    def add(self, local_path: Path, remote_path: str) -> Optional[Transfer]:
+        """Plan the *local_path* upload to the given *remote_path*.
+        Return the Transfer item.
+        """
+        if self.already_added(local_path):
+            log.debug(f"{local_path!r} is already part of the upload list")
+            return None
+
+        try:
+            is_file = local_path.is_file()
+            size = local_path.stat().st_size
+        except OSError:
+            log.warning(f"Skipping errored {local_path!r}", exc_info=True)
+            return None
+        else:
+            # Folders have no size
+            if not is_file:
+                size = 0
+
+        transfer: Transfer = Transfer.create(
+            session=self.session.id,
+            local_path=local_path,
+            remote_path=remote_path,
+            is_file=is_file,
+            file_size=size,
+        )
+        log.debug(
+            f"Added {local_path!r} to the upload list of session {self.session.id}"
+        )
+        self.transfers.append(transfer)
+        return transfer
+
+    def add_all(self, local_paths: Set[Path], remote_path: str) -> None:
+        """Recursively plan *local_paths* upload to the given *remote_path*."""
+        for local_path in sorted(local_paths):
+            if local_path.is_file():
+                self.add(local_path, remote_path)
+            elif local_path.is_dir():
+                tree = get_tree_list(local_path, remote_path)
+                for computed_remote_path, path in sorted(tree):
+                    self.add(path, computed_remote_path)
+
+    def already_added(self, local_path: Path) -> bool:
+        """Return True if a given *local_path* is already planned for upload."""
+        return any(transfer.local_path == local_path for transfer in self.transfers)
+
+    def cancel(self, file: Path) -> None:
+        """Cancel the transfer of the given local *file*.
+        This method is used when a duplicate creation would happen but
+        the user asked to cancel the upload.
+        """
+        for transfer in self.transfers:
+            if transfer.local_path != file:
+                continue
+
+            log.info(f"Transfer of {file!r} cancelled (user choice)")
+            transfer.status = TransferStatus.ABORTED  # type: ignore
+            transfer.save()
+            self.requeue(transfer)
+
+    def has_transfers_to_handle(self) -> bool:
+        """Check if transfers are all either completed or aborted."""
+        return not all(
+            transfer.status in (TransferStatus.DONE, TransferStatus.ABORTED)
+            for transfer in self.transfers
+        )
+
+    def init_db(self, db: str) -> None:
+        """Initialize the database."""
+        DATABASE.init(db)
+        DATABASE.connect()
+        DATABASE.create_tables(MODELS)
+
+    def inject(self) -> None:
+        """Inject new methods into the Remote client."""
+        self.remote.dt_upload = uploader.dt_upload
+        self.remote.dt_do_upload = uploader.dt_do_upload
+        self.remote.dt_link_blob_to_doc = uploader.dt_link_blob_to_doc
+        self.remote.dt_upload_chunks = uploader.dt_upload_chunks
+
+    def replace_blob(self, file: Path, doc_uid: str) -> None:
+        """Replace the document's blob on the server.
+        This method is used when a duplicate creation would happen and
+        the user asked to replace the attached blob.
+        """
+        for transfer in self.transfers:
+            if transfer.local_path != file:
+                continue
+
+            log.info(
+                "Replacing the document's attached file "
+                f"(UID is {doc_uid!r}) for {file!r} (user choice)"
+            )
+            transfer.replace_blob = True
+            transfer.save()
+            self.requeue(transfer)
+
+    def requeue(self, transfer: Transfer) -> None:
+        """Repush the given *transfer* into the queue, at the beginning."""
+        self._iterator.appendleft(transfer)
+        log.debug(f"Re-queued {transfer.local_path!r}")
+        if not self.is_started:
+            self.start()
+
+    def reset(self) -> None:
+        """Reset data and start a new transfers session."""
+        if self.is_started:
+            log.warning("Cannot reset as there are ongoing transfers.")
+            return
+
+        if not self.session.started:
+            log.warning("Cannot reset unstarted session transfers.")
+            return
+
+        if self.session.status is not TransferStatus.DONE:
+            self.session.finished = datetime.now()
+            self.session.status = TransferStatus.ABORTED
+            self.session.save()
+
+        self._iterator.clear()
+        self.transfers = []
+        self.session = Session.create()
+
+    def should_stop(self) -> bool:
+        """Method calls before uploading any local path to let the possibility to abort the session."""
+        # .stop() has been called
+        return not self.is_started
+
+    def start(self) -> None:
+        """Start transfers."""
+        msg = f"Direct Transfer session {self.session.id}"
+
+        if self.is_started:
+            log.warning(f"{msg} already running ... ")
+            return
+
+        if self.session.status is TransferStatus.DONE:
+            log.info(f"{msg} already completed.")
+            return
+
+        log.info(f"{msg} starting ...")
+
+        if not self.session.started:
+            self.session.started = datetime.now()
+            self.session.save()
+
+        self.is_started = True
+        try:
+            for transfer in self:
+                if self.should_stop():
+                    break
+
+                if transfer.status in (TransferStatus.DONE, TransferStatus.ABORTED):
+                    # That means the local path was either:
+                    # - already processed
+                    # - cancelled
+                    # - locally removed
+                    continue
+
+                if transfer.error_count >= 3:
+                    transfer.error_count = 0
+                    self.stop()
+
+                self.upload(transfer)
+        finally:
+            self.is_started = False
+
+        if not self.is_completed:
+            log.info(f"{msg} ended (progression: {self.progress}%).")
+            return
+
+        self.session.finished = datetime.now()
+        self.session.status = TransferStatus.DONE
+        self.session.save()
+        elapsed = self.session.finished - self.session.started
+        log.info(f"{msg} finished in {elapsed}!")
+
+    def shutdown(self) -> None:
+        """Stop everything."""
+        log.debug("Shutting down the Direct Transfer manager ...")
+        self.stop()
+        if not DATABASE.is_closed():
+            DATABASE.close()
+
+    def stop(self) -> None:
+        """Stop transfers."""
+        if not self.is_started:
+            return
+
+        log.info(f"Direct Transfer session {self.session.id} stopping ...")
+
+        self.is_started = False
+        for transfer in self.transfers:
+            if transfer.status is not TransferStatus.ONGOING:
+                continue
+
+            transfer.status = TransferStatus.SUSPENDED  # type: ignore
+            transfer.save()
+
+    def upload_impl(self, transfer: Transfer) -> None:
+        """Process a Transfer."""
+        # Pre-check: the local path must exist
+        transfer.local_path.stat()
+
+        # If no error, do the upload
+        transfer.status = TransferStatus.ONGOING  # type: ignore
+
+        runner = Runner(
+            target=self.remote.dt_upload,
+            args=(self.remote, transfer),
+            kwargs={"chunk_callback": self.chunk_callback},
+        )
+        runner.start()
+
+        while runner.is_alive():
+            # Do not block the GUI
+            QCoreApplication.processEvents()
+
+            # The application is being stopped
+            if State.about_to_quit:
+                self.stop()
+                break
+
+        runner.join()
+        if runner.error:
+            # An exception occurred, re-raise it
+            raise runner.error from None
+
+        # And trigger the "done" callback
+        self.done_callback(not transfer.is_file, transfer.file_size)
+
+    def upload(self, transfer: Transfer) -> None:
+        """Process a Transfer with error management."""
+        try:
+            self.upload_impl(transfer)
+        except FileNotFoundError:
+            log.info(
+                f"Removing {transfer.local_path!r} from transfers as it does not exist anymore"
+            )
+            transfer.status = TransferStatus.ABORTED  # type: ignore
+            transfer.save()
+        except uploader.DirectTransferPaused:
+            log.info(f"Pausing transfer of {transfer.local_path!r}")
+            transfer.status = TransferStatus.PAUSED  # type: ignore
+            transfer.save()
+            self.stop()
+        except CONNECTION_ERROR as exc:
+            log.warning(f"Network error for {transfer.local_path!r}", exc_info=True)
+            transfer.error = type(exc).__name__
+            transfer.error_count += 1
+            transfer.save()
+            self.requeue(transfer)
+        except uploader.DirectTransferDuplicateFoundError as exc:
+            log.info(str(exc))
+            log.debug(f"Calling {self.dupe_callback} to ask what action to do")
+            self.dupe_callback(exc.file, exc.doc)
+        except Exception as exc:
+            # On any error, skip and retry on the next call to .start()
+            # It has to be done manually.
+            log.warning(f"Oups, cannot upload {transfer.local_path!r}", exc_info=True)
+            transfer.error = type(exc).__name__
+            transfer.error_count += 1
+            transfer.save()
+            self.requeue(transfer)
diff --git a/nxdrive/direct_transfer/models.py b/nxdrive/direct_transfer/models.py
new file mode 100644
index 000000000..fb708070c
--- /dev/null
+++ b/nxdrive/direct_transfer/models.py
@@ -0,0 +1,136 @@
+# coding: utf-8
+"""
+The Direct Transfer feature.
+
+What: SQL models.
+"""
+import json
+from pathlib import Path
+
+from nuxeo.models import Batch
+from peewee import (
+    BooleanField,
+    CharField,
+    DateTimeField,
+    Field,
+    ForeignKeyField,
+    IntegerField,
+    Model,
+    SqliteDatabase,
+)
+
+from ..constants import TransferStatus
+
+# https://sqlite.org/pragma.html
+PRAGMAS = (
+    ("foreign_keys", 1),
+    ("journal_mode", "wal"),
+    ("synchronous", 3),
+    ("wal_checkpoint", 100),
+)
+
+# Note: using None instead of a the real database file, it will be set later
+#       via DATABASE.init(FILE) in DirectTransferManager.init_db().
+DATABASE = SqliteDatabase(None, check_same_thread=False, pragmas=PRAGMAS)
+
+
+def empty_batch() -> Batch:
+    """Empty batch for BatchField."""
+    return Batch()
+
+
+class BaseModel(Model):
+    """Base class for all models."""
+
+    class Meta:
+        """The database to use for all models."""
+
+        database = DATABASE
+        only_save_dirty = True
+
+
+class BatchField(Field):
+    """Custom field to handle Batch objects."""
+
+    field_type = "batch"
+    unserializable = {"blobs"}
+
+    def db_value(self, batch: Batch) -> str:
+        """Convert the Batch to a serialized dict for database storage.
+        Any value that cannot be serialized is wiped out.
+        """
+        obj = {k: v for k, v in batch.as_dict().items() if k not in self.unserializable}
+        return json.dumps(obj)
+
+    def python_value(self, batch: str) -> Batch:
+        """Get back the Batch from the stored serialized dict (string)."""
+        return Batch(**json.loads(batch))
+
+
+class PathField(Field):
+    """Custom field to handle Path objects."""
+
+    field_type = "path"
+
+    def db_value(self, value: Path) -> str:
+        """Convert the path to a string for database storage."""
+        return str(value)
+
+    def python_value(self, value: str) -> Path:
+        """Get back the path from the stored string."""
+        return Path(value)
+
+
+class StatusField(Field):
+    """Custom field to handle TransferStatus objects."""
+
+    field_type = "status"
+
+    def db_value(self, status: TransferStatus) -> int:
+        """Convert the path to a string for database storage."""
+        return int(status.value)
+
+    def python_value(self, status: int) -> TransferStatus:
+        """Get back the path from the stored string."""
+        return TransferStatus(status)
+
+
+class Session(BaseModel):
+    """Represent a Direct Transfer session.
+    A session is a batch of transfers: each time a new Direct Transfer is initiated, a new session is created.
+    """
+
+    started = DateTimeField(null=True)
+    finished = DateTimeField(null=True)
+    status = StatusField(default=TransferStatus.ONGOING)
+
+
+class Transfer(BaseModel):
+    """Represent a Direct Transfer item."""
+
+    session = ForeignKeyField(Session)
+    local_path = PathField()
+    remote_path = CharField()
+    is_file = BooleanField(default=False)
+    file_size = IntegerField(default=0)
+    status = StatusField(default=TransferStatus.ONGOING)
+    batch = BatchField(default=empty_batch)
+    remote_ref = CharField(null=True)
+    doctype = CharField(null=True)
+    uploaded_size = IntegerField(default=0)
+    uploaded = BooleanField(default=False)
+    chunk_size = IntegerField(default=0)
+    replace_blob = BooleanField(default=False)
+    error_count = IntegerField(default=0)
+    error = CharField(null=True)
+
+    class Meta:
+        """Create indexes."""
+
+        indexes = (
+            # Create a unique on session/local_path/remote_path combination
+            (("session", "local_path", "remote_path"), True),
+        )
+
+
+MODELS = [Session, Transfer]
diff --git a/nxdrive/direct_transfer/runner.py b/nxdrive/direct_transfer/runner.py
new file mode 100644
index 000000000..dc3e3f588
--- /dev/null
+++ b/nxdrive/direct_transfer/runner.py
@@ -0,0 +1,26 @@
+# coding: utf-8
+"""
+The Direct Transfer feature.
+
+What: threaded runner.
+"""
+from threading import Thread
+from typing import Any, Optional
+
+
+class Runner(Thread):
+    """Simple runner used for every single upload.
+    Any exception will be forwarded to the caller via the .error attribute.
+    """
+
+    def __init__(self, *args: Any, **kwargs: Any) -> None:
+        """Simple init to declare .error that is used to communicate eventual exceptions to the caller."""
+        super().__init__(*args, **kwargs)
+        self.error: Optional[Exception] = None
+
+    def run(self) -> None:
+        """Catch any error and store it inside the .error attribute instead of throwing it."""
+        try:
+            super().run()
+        except Exception as exc:
+            self.error = exc
